## Tools to streamline sending data to the prediction service application endpoint
# Sending post requests, multiprocessing functions, etc
import requests


def send_post_request(payload, endpoint):
    resp = requests.post(endpoint, json={'body':payload})
    return resp
    
    
def get_pred_class_from_response(resp):
    response = resp.json()
    pred_class = response['predictions']['class']
    return pred_class


def update_prediction_dictionary(i, pred_class, predictions):
    if (len(pred_class) != 0) and (len(predictions) == 1): # first instance of a predicted class
        predictions['ghost'] = 'no'
    predictions[i] = pred_class
    return predictions

####
####
# Work in progress

def process_video_multiprocessing(_inputs):
    group_number = _inputs[0]
    file_name = _inputs[1]
    frame_jump_unit = _inputs[2]
    
    print(f"File {file_name}, group {group_number}, jump_unit {frame_jump_unit}")

    # Read video file
    cap = cv2.VideoCapture(file_name)
    vidname = file_name.split('/')[-1].split('.')[0]

    cap.set(cv2.CAP_PROP_POS_FRAMES, frame_jump_unit * group_number)

    # get height, width and frame count of the video
    width, height = (
            int(cap.get(cv2.CAP_PROP_FRAME_WIDTH)),
            int(cap.get(cv2.CAP_PROP_FRAME_HEIGHT))
        )
    no_of_frames = int(cap.get(cv2.CAP_PROP_FRAME_COUNT))
    fps = int(cap.get(cv2.CAP_PROP_FPS))
    proc_frames = 0
    
    # Set master frame index
    i = proc_frames + frame_jump_unit * group_number

    # Define the codec and create VideoWriter object
#     fourcc = cv2.VideoWriter_fourcc('m', 'p', '4', 'v')
#     out = cv2.VideoWriter()
#     output_file_name = "output_multi.mp4"
#     out.open("output_{}.mp4".format(group_number), fourcc, fps, (width, height), True)

    # Create predictions object
    predictions = {}
    try:
        while proc_frames < frame_jump_unit:
            ret, frame = cap.read()
            if not ret:
                break
            print(i)
            im = frame
            # Generate prediction for each frame
            _, pred_class, _ = get_prediction(model, im, threshold=.5, is_frame=True)
            print('prediction.')
            if (len(pred_class) != 0) and len(predictions) == 0:
                predictions['ghost'] = 'no'
            predictions[i] = pred_class
            
            # Loop through list (if empty this will be skipped) and overlay green bboxes
#             for i in bboxes:
#                 cv2.rectangle(im, (i[0], i[1]), (i[2], i[3]), (0, 255, 0), 3)
            
            # write the frame
#             out.write(im)

            proc_frames += 1
    except:
        # Release resources
        cap.release()
        out.release()

    # Release resources
    cap.release()
    out.release()
    
    # write predictions to disk
    with open(f"predictions/{vidname}_{group_numer}.json", "w") as f:
        json.dump(predictions, f)
        

def merge_dicts(file_name, vidname=False):
    """Combines prediciton dictionaries generated by multiprocessing into a single master dicitonary"""
    
    if filename and not vidname:
        vidname = filename.split('/')[-1].split('.')[0]
    # list all prediction files for the video
    pred_files = [file for file in os.listdir("./predictions") if file.startswith(vidname)]
    
    # convert prediction files to dictionaries
    pred_dicts = [json.load(file) for file in pred_files]
    
    # merge dictionaries into one
    base_dict = pred_dicts.pop()
    for _dict in pred_dicts:
        base_dict.update(_dict)
    
    # save base dictionary
    with open(f'predicitons/{vidname}.json', 'w') as f:
        json.dump(base_dict, f)
        
        
def multi_process(file_name, num_processes):
    print(f"Video processing using {num_processes} processes...")
    start_time = time.time()
    jump_unit = 900/num_processes

    # Paralle the execution of a function across multiple input values
    p = mp.Pool(num_processes)
    _inputs = iter(zip(range(num_processes),[file_name]*num_processes, [jump_unit]*num_processes))
    p.map(process_video_multiprocessing, _inputs)

    merge_dicts(file_name)

    end_time = time.time()

    total_processing_time = end_time - start_time
    print("Time taken: {}".format(total_processing_time))
    print("FPS : {}".format(frame_count/total_processing_time))